<?php

namespace Teknisa\SM\Util\Procedure;

use Doctrine\DBAL\Connection;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;

class FctConsisteFeriBanc {
    
    const NOME = "FCT_CONSISTE_FERI_BANC";
    protected $connection;
    
    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }
    
    /**
     * Executa a procedure.
     * 
     * @param string  $cdfilial
     * @param string  $dtvencimento
     * @param string  $idtipodtpgto
     * @param string  $dtreferencia
     * 
     * @return mixed[]
     */
    public function executar($cdfilial, $dtvencimento, $idtipodtpgto, $dtreferencia) {
        $procedure = new StoredProcedure($this->connection, self::NOME);
        
        //Entrada
        $procedure->addParam(new Param("P_CDFILIAL",      Param::PARAM_INPUT,   $cdfilial,      Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_DTVENCIMENTO",  Param::PARAM_INPUT,   $dtvencimento,  Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_DTVENC",        Param::PARAM_OUTPUT,  null,           Param::PARAM_TYPE_STR, 20));
        $procedure->addParam(new Param("P_IDTIPODTPGTO",  Param::PARAM_INPUT,   $idtipodtpgto,  Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_DTREFERENCIA",  Param::PARAM_INPUT,   $dtreferencia,  Param::PARAM_TYPE_STR));
        
        $retorno = $procedure->execute();
        $data = $retorno["P_DTVENC"];
        return explode(" ", $data)[0];
    }
    
}

?>