/* Sistemas Integrados TECNISA

Nome: 0102_FISTRGS.SQL

Descrio:
   Trigger apagar vnculo da nota fiscal com o mapa de apurao

Criao:
   29/10/2012 - Felipe Santos

Tabela NOTAFISCAL: Nota Fiscal.
Descrio: A trigger apaga o contedo do campo DTREFMAPAPU na tabela NOTAFISCAL a partir do
desaprovao ou cancelamento da emisso da nota fiscal.
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
            WHERE O.NAME = 'DT_REFERENCIA_MAPA'
              AND TYPE   = 'TR'
   	      AND U.UID  = O.UID
     	      AND U.NAME = USER)
DROP TRIGGER DT_REFERENCIA_MAPA
GO

CREATE TRIGGER DT_REFERENCIA_MAPA
ON NOTAFISCAL
FOR UPDATE
AS
   DECLARE @V_CDFILIAL_OLD   VARCHAR(4);
   DECLARE @V_NRLANCTONF_OLD VARCHAR(10);
   DECLARE @V_IDSTATUS_OLD   VARCHAR(1);
   DECLARE @V_CDFILIAL_NEW   VARCHAR(4);
   DECLARE @V_NRLANCTONF_NEW VARCHAR(10);
   DECLARE @V_IDSTATUS_NEW   VARCHAR(1);
BEGIN
   DECLARE C_DT_REFERENCIA_MAPA CURSOR FOR
      SELECT DELETED.CDFILIAL, DELETED.NRLANCTONF, DELETED.IDSTATUS,
             INSERTED.CDFILIAL, INSERTED.NRLANCTONF, INSERTED.IDSTATUS
        FROM DELETED, INSERTED
       WHERE INSERTED.CDFILIAL = DELETED.CDFILIAL
         AND INSERTED.NRLANCTONF = DELETED.NRLANCTONF;
   OPEN C_DT_REFERENCIA_MAPA;
   FETCH NEXT FROM C_DT_REFERENCIA_MAPA INTO @V_CDFILIAL_OLD, @V_NRLANCTONF_OLD, @V_IDSTATUS_OLD,
                                 @V_CDFILIAL_NEW, @V_NRLANCTONF_NEW, @V_IDSTATUS_NEW;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF (@V_IDSTATUS_NEW <> @V_IDSTATUS_OLD) BEGIN
         IF (@V_IDSTATUS_NEW NOT IN ('A','E')) BEGIN
            UPDATE NOTAFISCAL
               SET DTREFMAPAPU = NULL
             WHERE CDFILIAL = @V_CDFILIAL_NEW
               AND NRLANCTONF = @V_NRLANCTONF_NEW;

            UPDATE IMPOSTONF
               SET DTREFMAPAPU = NULL
             WHERE CDFILIAL   = @V_CDFILIAL_NEW
               AND NRLANCTONF = @V_NRLANCTONF_NEW;
         END;
      END;
      FETCH NEXT FROM C_DT_REFERENCIA_MAPA INTO @V_CDFILIAL_OLD, @V_NRLANCTONF_OLD, @V_IDSTATUS_OLD,
                                    @V_CDFILIAL_NEW, @V_NRLANCTONF_NEW, @V_IDSTATUS_NEW;
   END;
   CLOSE C_DT_REFERENCIA_MAPA;
   DEALLOCATE C_DT_REFERENCIA_MAPA;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DT_REFERENCIA_MAPA','5.65.000';
GO
